3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
33 # Resolve relative url by appending to parent's url
34 resolve_relative_url ()
36 remote=$(get_default_remote)
37 remoteurl=$(git config "remote.$remote.url") ||
38 remoteurl=$(pwd) # the repository is its own authoritative upstream
40 remoteurl=${remoteurl%/}
49 remoteurl="${remoteurl%/*}"
52 remoteurl="${remoteurl%:*}"
56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
67 echo "$remoteurl$sep${url%/}"
71 # Get submodule info for registered submodules
72 # $@ = path to limit submodule list
76 git ls-files --error-unmatch --stage -- "$@" |
79 my ($null_sha1) = ("0" x 40);
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
97 # Map submodule path to submodule name
103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
104 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
105 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
106 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
108 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$path'")"
115 # Prior to calling, cmd_update checks that a possibly existing
116 # path is not a git repository.
117 # Likewise, cmd_add checks that path does not exist at all,
118 # since it is the location of a new submodule.
126 if test -n "$GIT_QUIET"
133 name=$(module_name "$path" 2>/dev/null)
134 test -n "$name" || name="$path"
135 base_name=$(dirname "$name")
137 gitdir=$(git rev-parse --git-dir)
138 gitdir_base="$gitdir/modules/$base_name"
139 gitdir="$gitdir/modules/$name"
144 rm -f "$gitdir/index"
146 mkdir -p "$gitdir_base"
147 git clone $quiet -n ${reference:+"$reference"} \
148 --separate-git-dir "$gitdir" "$url" "$path" ||
149 die "$(eval_gettext "Clone of '\$url' into submodule path '\$path' failed")"
152 a=$(cd "$gitdir" && pwd)/
153 b=$(cd "$path" && pwd)/
154 # normalize Windows-style absolute paths to POSIX-style absolute paths
155 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
156 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
157 # Remove all common leading directories after a sanity check
158 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
159 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
161 while test "${a%%/*}" = "${b%%/*}"
166 # Now chop off the trailing '/'s that were added in the beginning
170 # Turn each leading "*/" component into "../"
171 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
172 echo "gitdir: $rel/$a" >"$path/.git"
174 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
175 (clear_local_git_env; cd "$path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
179 # Add a new submodule to the working tree, .gitmodules and the index
183 # optional branch is stored in global branch variable
187 # parse $args after "submodule ... add".
192 case "$2" in '') usage ;; esac
203 case "$2" in '') usage ;; esac
204 reference="--reference=$2"
228 if test -z "$path"; then
229 path=$(echo "$repo" |
230 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
233 if test -z "$repo" -o -z "$path"; then
237 # assure repo is absolute or relative to parent
240 # dereference source url relative to parent's url
241 realrepo=$(resolve_relative_url "$repo") || exit
248 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
253 # multiple //; leading ./; /./; /../; trailing /
254 path=$(printf '%s/\n' "$path" |
264 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
265 die "$(eval_gettext "'\$path' already exists in the index")"
267 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
269 eval_gettextln "The following path is ignored by one of your .gitignore files:
271 Use -f if you really want to add it." >&2
275 # perhaps the path exists and is already a git repo, else clone it
278 if test -d "$path"/.git -o -f "$path"/.git
280 eval_gettextln "Adding existing repo at '\$path' to the index"
282 die "$(eval_gettext "'\$path' already exists and is not a valid git repo")"
287 module_clone "$path" "$realrepo" "$reference" || exit
291 # ash fails to wordsplit ${branch:+-b "$branch"...}
293 '') git checkout -f -q ;;
294 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
296 ) || die "$(eval_gettext "Unable to checkout submodule '\$path'")"
298 git config submodule."$path".url "$realrepo"
300 git add $force "$path" ||
301 die "$(eval_gettext "Failed to add submodule '\$path'")"
303 git config -f .gitmodules submodule."$path".path "$path" &&
304 git config -f .gitmodules submodule."$path".url "$repo" &&
305 git add --force .gitmodules ||
306 die "$(eval_gettext "Failed to register submodule '\$path'")"
310 # Execute an arbitrary command sequence in each checked out
313 # $@ = command to execute
317 # parse $args after "submodule ... foreach".
339 # dup stdin so that it can be restored when running the external
340 # command in the subshell (and a recursive call to this function)
344 while read mode sha1 stage path
346 if test -e "$path"/.git
348 say "$(eval_gettext "Entering '\$prefix\$path'")"
349 name=$(module_name "$path")
351 prefix="$prefix$path/"
355 if test -n "$recursive"
357 cmd_foreach "--recursive" "$@"
360 die "$(eval_gettext "Stopping at '\$path'; script returned non-zero status.")"
366 # Register submodules in .git/config
368 # $@ = requested paths (default to all)
372 # parse $args after "submodule ... init".
394 while read mode sha1 stage path
396 # Skip already registered paths
397 name=$(module_name "$path") || exit
398 if test -z "$(git config "submodule.$name.url")"
400 url=$(git config -f .gitmodules submodule."$name".url)
402 die "$(eval_gettext "No url found for submodule path '\$path' in .gitmodules")"
404 # Possibly a url relative to parent
407 url=$(resolve_relative_url "$url") || exit
410 git config submodule."$name".url "$url" ||
411 die "$(eval_gettext "Failed to register url for submodule path '\$path'")"
414 # Copy "update" setting when it is not set yet
415 upd="$(git config -f .gitmodules submodule."$name".update)"
417 test -n "$(git config submodule."$name".update)" ||
418 git config submodule."$name".update "$upd" ||
419 die "$(eval_gettext "Failed to register update mode for submodule path '\$path'")"
421 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$path'")"
426 # Update each submodule path to correct revision, using clone and checkout as needed
428 # $@ = requested paths (default to all)
432 # parse $args after "submodule ... update".
453 case "$2" in '') usage ;; esac
454 reference="--reference=$2"
455 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
481 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
487 cmd_init "--" "$@" || return
493 while read mode sha1 stage path
497 echo >&2 "Skipping unmerged submodule $path"
500 name=$(module_name "$path") || exit
501 url=$(git config submodule."$name".url)
502 if ! test -z "$update"
504 update_module=$update
506 update_module=$(git config submodule."$name".update)
509 if test "$update_module" = "none"
511 echo "Skipping submodule '$path'"
517 # Only mention uninitialized submodules when its
518 # path have been specified
520 say "$(eval_gettext "Submodule path '\$path' not initialized
521 Maybe you want to use 'update --init'?")"
525 if ! test -d "$path"/.git -o -f "$path"/.git
527 module_clone "$path" "$url" "$reference"|| exit
528 cloned_modules="$cloned_modules;$name"
531 subsha1=$(clear_local_git_env; cd "$path" &&
532 git rev-parse --verify HEAD) ||
533 die "$(eval_gettext "Unable to find current revision in submodule path '\$path'")"
536 if test "$subsha1" != "$sha1"
539 # If we don't already have a -f flag and the submodule has never been checked out
540 if test -z "$subsha1" -a -z "$force"
545 if test -z "$nofetch"
547 # Run fetch only if $sha1 isn't present or it
548 # is not reachable from a ref.
549 (clear_local_git_env; cd "$path" &&
550 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
551 test -z "$rev") || git-fetch)) ||
552 die "$(eval_gettext "Unable to fetch in submodule path '\$path'")"
555 # Is this something we just cloned?
556 case ";$cloned_modules;" in
558 # then there is no local change to integrate
563 case "$update_module" in
566 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$path'")"
567 say_msg="$(eval_gettext "Submodule path '\$path': rebased into '\$sha1'")"
568 must_die_on_failure=yes
572 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$path'")"
573 say_msg="$(eval_gettext "Submodule path '\$path': merged in '\$sha1'")"
574 must_die_on_failure=yes
577 command="git checkout $subforce -q"
578 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$path'")"
579 say_msg="$(eval_gettext "Submodule path '\$path': checked out '\$sha1'")"
583 if (clear_local_git_env; cd "$path" && $command "$sha1")
586 elif test -n "$must_die_on_failure"
588 die_with_status 2 "$die_msg"
590 err="${err};$die_msg"
595 if test -n "$recursive"
597 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags")
601 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$path'")"
604 err="${err};$die_msg"
607 die_with_status $res "$die_msg"
634 git describe "$2" 2>/dev/null ||
635 git describe --tags "$2" 2>/dev/null ||
636 git describe --contains "$2" 2>/dev/null ||
637 git describe --all --always "$2"
640 test -z "$revname" || revname=" ($revname)"
643 # Show commit summary for submodules in index or working tree
645 # If '--cached' is given, show summary between index and given commit,
646 # or between working tree and given commit
648 # $@ = [commit (default 'HEAD'),] requested paths (default all)
655 # parse $args after "submodule ... summary".
669 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
691 test $summary_limit = 0 && return
693 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
697 elif test -z "$1" -o "$1" = "HEAD"
699 # before the first commit: compare with an empty tree
700 head=$(git hash-object -w -t tree --stdin </dev/null)
701 test -z "$1" || shift
709 die "$(gettext -- "--cached cannot be used with --files")"
715 # Get modified modules cared by user
716 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
717 sane_egrep '^:([0-7]* )?160000' |
718 while read mod_src mod_dst sha1_src sha1_dst status name
720 # Always show modules deleted or type-changed (blob<->module)
721 test $status = D -o $status = T && echo "$name" && continue
722 # Also show added or modified modules which are checked out
723 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
728 test -z "$modules" && return
730 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
731 sane_egrep '^:([0-7]* )?160000' |
733 while read mod_src mod_dst sha1_src sha1_dst status name
735 if test -z "$cached" &&
736 test $sha1_dst = 0000000000000000000000000000000000000000
740 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
742 100644 | 100755 | 120000)
743 sha1_dst=$(git hash-object $name)
749 eval_gettextln "unexpected mode \$mod_dst" >&2
756 test $mod_src = 160000 &&
757 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
760 test $mod_dst = 160000 &&
761 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
765 case "$missing_src,$missing_dst" in
767 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
770 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
773 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
778 if test $mod_src = 160000 -a $mod_dst = 160000
780 range="$sha1_src...$sha1_dst"
781 elif test $mod_src = 160000
787 GIT_DIR="$name/.git" \
788 git rev-list --first-parent $range -- | wc -l
790 total_commits=" ($(($total_commits + 0)))"
794 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
795 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
798 blob="$(gettext "blob")"
799 submodule="$(gettext "submodule")"
800 if test $mod_dst = 160000
802 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
804 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
807 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
811 # Don't give error msg for modification whose dst is not submodule
812 # i.e. deleted or changed to blob
813 test $mod_dst = 160000 && echo "$errmsg"
815 if test $mod_src = 160000 -a $mod_dst = 160000
818 test $summary_limit -gt 0 && limit="-$summary_limit"
819 GIT_DIR="$name/.git" \
820 git log $limit --pretty='format: %m %s' \
821 --first-parent $sha1_src...$sha1_dst
822 elif test $mod_dst = 160000
824 GIT_DIR="$name/.git" \
825 git log --pretty='format: > %s' -1 $sha1_dst
827 GIT_DIR="$name/.git" \
828 git log --pretty='format: < %s' -1 $sha1_src
834 if test -n "$for_status"; then
835 if [ -n "$files" ]; then
836 gettextln "# Submodules changed but not updated:"
838 gettextln "# Submodule changes to be committed:"
841 sed -e 's|^|# |' -e 's|^# $|#|'
847 # List all submodules, prefixed with:
848 # - submodule not initialized
849 # + different revision checked out
851 # If --cached was specified the revision in the index will be printed
852 # instead of the currently checked out revision.
854 # $@ = requested paths (default to all)
858 # parse $args after "submodule ... status".
883 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
888 while read mode sha1 stage path
890 name=$(module_name "$path") || exit
891 url=$(git config submodule."$name".url)
892 displaypath="$prefix$path"
895 say "U$sha1 $displaypath"
898 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
900 say "-$sha1 $displaypath"
903 set_name_rev "$path" "$sha1"
904 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
906 say " $sha1 $displaypath$revname"
910 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
911 set_name_rev "$path" "$sha1"
913 say "+$sha1 $displaypath$revname"
916 if test -n "$recursive"
919 prefix="$displaypath/"
922 eval cmd_status "$orig_args"
924 die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
929 # Sync remote urls for submodules
930 # This makes the value for remote.$remote.url match the value
931 # specified in .gitmodules.
956 while read mode sha1 stage path
958 name=$(module_name "$path")
959 url=$(git config -f .gitmodules --get submodule."$name".url)
961 # Possibly a url relative to parent
964 url=$(resolve_relative_url "$url") || exit
968 if git config "submodule.$name.url" >/dev/null 2>/dev/null
970 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
971 git config submodule."$name".url "$url"
973 if test -e "$path"/.git
978 remote=$(get_default_remote)
979 git config remote."$remote".url "$url"
986 # This loop parses the command line arguments to find the
987 # subcommand name to dispatch. Parsing of the subcommand specific
988 # options are primarily done by the subcommand implementations.
989 # Subcommand specific options such as --branch and --cached are
990 # parsed here as well, for backward compatibility.
992 while test $# != 0 && test -z "$command"
995 add | foreach | init | update | status | summary | sync)
1025 # No command word defaults to "status"
1026 test -n "$command" || command=status
1028 # "-b branch" is accepted only by "add"
1029 if test -n "$branch" && test "$command" != add
1034 # "--cached" is accepted only by "status" and "summary"
1035 if test -n "$cached" && test "$command" != status -a "$command" != summary